# PersonalFME - Gateway linking analog radio selcalls to internet communication services
# Copyright(C) 2010-2017 Ralf Rettig (www.personalfme.de)
#
# This program is free software: you can redistribute it and / or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.If not, see <http://www.gnu.org/licenses/>

# Determines the binary paths of the given Boost libraries on Windows (DLLs)
#
# Parameters:
# List of Boost libraries(for example: GetBoostReleaseBins( system filesystem thread ) )
#
# Returned variable:
# BOOST_BINS_RELEASE				- List containing the release binary paths of all libraries

function( GetBoostReleaseBins )
	foreach( LIB ${ARGV}  )
		string( TOUPPER "${LIB}" _LIB_UPPERCASE )
		get_filename_component( _UTF_BASE_NAME 
			${Boost_${_LIB_UPPERCASE}_LIBRARY_RELEASE} NAME_WE )		
		get_filename_component( _UTF_PATH 
		${Boost_${_LIB_UPPERCASE}_LIBRARY_RELEASE} PATH )	
	
		list( APPEND BOOST_BINS_RELEASE ${_UTF_PATH}/${_UTF_BASE_NAME}.dll )
	endforeach()

	set( BOOST_BINS_RELEASE ${BOOST_BINS_RELEASE} PARENT_SCOPE )
endfunction()
