/*	PersonalFME - Gateway linking analog radio selcalls to internet communication services
Copyright(C) 2010-2017 Ralf Rettig (www.personalfme.de)

This program is free software: you can redistribute it and / or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.If not, see <http://www.gnu.org/licenses/>
*/
#pragma once

#include <boost/asio.hpp>
#include <boost/thread.hpp>
#include "FMESession.h"
#include "FMESessionManager.h"


/*@{*/
/** \ingroup Networking
*/

/**	\ingroup Networking
*	Pimple idiom for hiding the private implementation details of CFMEServer
*/
class Networking::CFMEServer::FMEServerPrivImplementation
{
public:
	FMEServerPrivImplementation(void);
	virtual ~FMEServerPrivImplementation(void);
	void HandleAccept(const boost::system::error_code& error);
	virtual void ResetConnection(void);

	std::function< void(const Utilities::CSeqData&) > foundCallback;
	boost::asio::io_service ioService;
	boost::asio::ip::tcp::acceptor acceptor;
	std::shared_ptr< Session::CFMESessionManager<float> > sessionManager;
	std::shared_ptr< Session::CFMESession<float> > newConnection;
	boost::mutex isRunningMutex;
	bool isRunning;
	bool isInit;
};

/*@}*/